<template>
  <div id="app">
    <navbar id="navbar"></navbar>
    <sidebar id="sidebar"></sidebar>
    <div id="content">
      <div id="area-main" :style="{ width: mainAreaWidth + '%' }">
        <div id="quick-add"><input type="text" class="form-control" placeholder="Add todo ..."></div>
        <todo-list v-on:todoItemSelected="onTodoItemSelected"></todo-list>
        <div style="height: 100%;" @click="onBlankAreaClick"></div>
      </div>
      <div id="area-side-panel" :style="{ display: sidePanelDisplay===true ? 'block' : 'none' }">
        <todo-detail class="todo-detail" ></todo-detail>
      </div>
    </div>
  </div>
</template>

<script>
import Navbar from './components/Navbar'
import Sidebar from './components/Sidebar'
import TodoList from './components/TodoList'
import TodoDetail from './components/TodoDetail'

export default {
  name: 'app',
  data () {
    return {
      mainAreaWidth: 100,
      sidePanelDisplay: false
    }
  },
  components: {
    Navbar, Sidebar, TodoList, TodoDetail
  },
  methods: {
    setSidePanelVisible (isVisible) {
      if (isVisible) {
        this.mainAreaWidth = 50
        this.sidePanelDisplay = true
      } else {
        this.mainAreaWidth = 100
        this.sidePanelDisplay = false
      }
    },
    showSidePanel () {
      this.setSidePanelVisible(true)
    },
    hideSidePanel () {
      this.setSidePanelVisible(false)
    },
    onContentAreaClick () {
      // In perfect status, all the area except todoitem can be clicked to hide panel
      this.hideSidePanel()
    },
    onTodoItemSelected () {
      this.showSidePanel()
    },
    onBlankAreaClick () {
      this.hideSidePanel()
    }
  },
  created () {
    this.$store.dispatch('getTodos')
  }
}
</script>

<style>
#app {
}

#navbar {
  z-index: 100;
}

#sidebar {
  position:absolute;
  left:0; top:50px; bottom: 0;
  width: 300px;
  border-right: 2px solid #E5E5E5;
  display: none;
}

#content {
  position: absolute;
  left: 0; top:50px; right:0; bottom:0;
  background-image: url('./assets/background.jpg');
  background-size: cover;
  padding: 5px;
}

#area-main {
  position: absolute;
  left: 0px;
  top: 0px;
  bottom: 0px;
  height: 100%;
  padding-left: 5px;
  padding-right: 5px;
}

#area-side-panel {
  position: absolute;
  right: 0px;
  top: 0px;
  bottom: 0px;
  width: 50%;
  height: 100%;
  padding: 10px 5px 10px 5px;
  display: flex;
  justify-content: center;
  align-items: center;
}

#quick-add {
  margin-top: 10px;
  margin-bottom: 5px;
}

.todo-detail {
  width: 100%;
  height: 100%;
}

</style>
